/**
   Interface used by a SonicObject to get input force.
   Copyright The University of British Columbia, Canada
   @author Kees van den Doel (kvdoel@cs.ubc.ca)
*/
public interface AudioForce {
    /** Return audio force.
        @param output user provided buffer for force returned.
        @param nsamples number of samples written to output buffer.
    */
    public void getForce(float [] output, int nsamples);
}
