/**
   Toll a bell.
 * Copyright The University of British Columbia, Canada
 * @author Kees van den Doel (kvdoel@cs.ubc.ca)
 */
public class DemoBellStrike extends java.awt.Dialog {

    /** Creates new form DemoBellStrike */
    public DemoBellStrike(java.awt.Frame parent,boolean modal) {
        super (parent, modal);
        initComponents ();
        pack ();
    }

    /** This method is called from within the init() method to
     * initialize the form.
     */
    private void initComponents () {
        jSlider1 = new javax.swing.JSlider ();
        jSlider2 = new javax.swing.JSlider ();
        setLayout (new java.awt.BorderLayout ());
        addWindowListener (new java.awt.event.WindowAdapter () {
                public void windowClosing (java.awt.event.WindowEvent evt) {
                    closeDialog (evt);
                    System.exit(0);
                }
            }
            );

        jSlider1.setMaximum (1000000);
        jSlider2.setMaximum (1000000);
        jSlider1.addMouseMotionListener (new java.awt.event.MouseMotionAdapter () {
                public void mouseDragged (java.awt.event.MouseEvent evt) {
                    jSlider1MouseDragged (evt);
                }
            }
            );
        jSlider2.addMouseMotionListener (new java.awt.event.MouseMotionAdapter () {
                public void mouseDragged (java.awt.event.MouseEvent evt) {
                    jSlider2MouseDragged (evt);
                }
            }
            );


        add (jSlider1, java.awt.BorderLayout.CENTER);
        add (jSlider2, java.awt.BorderLayout.SOUTH);

    }

    private void jSlider1MouseDragged (java.awt.event.MouseEvent evt) {
        double val = jSlider1.getValue()/1000000.;
        double min = .00001; // sharp hit
        double max = .01;   // soft hit
        double x = (max-min)*val + min;
        af1.setDuration((float)x);
        System.out.println("dur="+x);
    }

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {
        setVisible (false);
        dispose ();
    }

    private void jSlider2MouseDragged (java.awt.event.MouseEvent evt) {
        double val = jSlider2.getValue()/1000000.;
        double min = 1;
        double max = (double)sob1.modalModel.nf;
        int x = (int)((max-min)*val + min);
        sob1.setNf(x);
        System.out.println("modes="+x);
    }
    
    static ModalSonicObject sob1=null;
    static BangForce af1;

    public static void main (String args[]) {
        float srate = 44100.f;
        int bufferSize = 1024;
        int bufferSizeJavaSound = 8*1024;
        if(args.length != 1) {
            System.out.println("Usage: java DemoBellStrike bell4.sy \n");
            return;
        }
        try {
            sob1 = new ModalSonicObject(new ModalModel(args[0]),
                                        srate,bufferSize,bufferSizeJavaSound);
        } catch(java.io.FileNotFoundException ee) {
            System.out.println("Cant open sy file\n");
            return;
        }
        af1 = new BangForce(srate);
        sob1.setAudioForce(af1);
        sob1.start();
        // create control thread
        new Thread() {
                int t_control = 2000; //In ms
                public void run() {
                    try {
                        while(true) {
                            sleep(t_control);
                            af1.hit();
                        }
                    } catch(InterruptedException ee) {
                    }
                }
            }.start();
        new DemoBellStrike (new java.awt.Frame (), true).show ();
    }

    private javax.swing.JSlider jSlider1;
    private javax.swing.JSlider jSlider2;

}


