/**
   Car engine model.
 * Copyright The University of British Columbia, Canada
 @author Kees van den Doel (kvdoel@cs.ubc.ca)
 */
public class DemoEngine extends java.awt.Dialog {

    /** Creates new form DemoEngine */
    public DemoEngine(java.awt.Frame parent,boolean modal) {
        super (parent, modal);
        initComponents ();
        pack ();
    }

    private void initComponents () {
        jSlider1 = new javax.swing.JSlider ();
        jSlider2 = new javax.swing.JSlider ();
        setLayout (new java.awt.BorderLayout ());
        addWindowListener (new java.awt.event.WindowAdapter () {
                public void windowClosing (java.awt.event.WindowEvent evt) {
                    closeDialog (evt);
                    System.exit(0);
                }
            }
            );

        jSlider1.setMaximum (1000000);
        jSlider2.setMaximum (1000000);
        jSlider1.addMouseMotionListener (new java.awt.event.MouseMotionAdapter () {
                public void mouseDragged (java.awt.event.MouseEvent evt) {
                    jSlider1MouseDragged (evt);
                }
            }
            );
        jSlider2.addMouseMotionListener (new java.awt.event.MouseMotionAdapter () {
                public void mouseDragged (java.awt.event.MouseEvent evt) {
                    jSlider2MouseDragged (evt);
                }
            }
            );


        add (jSlider1, java.awt.BorderLayout.CENTER);
        add (jSlider2, java.awt.BorderLayout.SOUTH);

    }

    private void jSlider1MouseDragged (java.awt.event.MouseEvent evt) {
        double val = jSlider1.getValue()/1000000.;
        double min = 2.,max=10;
        double v = val*(max-min)+min;
        System.out.println("speed="+(float)v);
        af.setSpeed((float)v);
    }

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {
        setVisible (false);
        dispose ();
    }

    private void jSlider2MouseDragged (java.awt.event.MouseEvent evt) {
        double val = jSlider2.getValue()/1000000.;
        val /= 10;
        af.setBeatupness((float)val);
        System.out.println("beatupness="+(float)val);

    }

    static ModalSonicObject sob;
    static CombustionEngineForce af;

    public static void main (String args[]) {
        float srate = 44100.f;
        int bufferSize = 128;
        int bufferSizeJavaSound = 8*1024;
        if(args.length != 2) {
            System.out.println("Usage: java DemoEngine car1.sy car2.wav\n");
            return;
        }
        try {
            sob = new ModalSonicObject(new ModalModel(args[0]),
                                       srate,bufferSize,bufferSizeJavaSound);
        } catch (java.io.FileNotFoundException ee) {
            System.out.println("Modes file not found\n");
        }
        af = new CombustionEngineForce(srate,args[1]);
        sob.setAudioForce(af);
        sob.start();
        new DemoEngine (new java.awt.Frame (), true).show ();
    }

    private javax.swing.JSlider jSlider1;
    private javax.swing.JSlider jSlider2;

}
