import java.io.*;

/** Touch object with mike input.
    Copyright The University of British Columbia, Canada
    @author Kees van den Doel (kvdoel@cs.ubc.ca)
*/
public class DemoMikeIn extends Thread {
    public static void main(String[] args) throws InterruptedException{
        float srate = 44100.f;
        int bufferSize = 128;
        int bufferSizeJavaSound = 16*1024;
        ModalSonicObject sob=null;
        if(args.length != 1) {
            System.out.println("Usage: java DemoMikeIn desklamp.sy\n");
            return;
        }
        try {
            sob = new ModalSonicObject(new ModalModel(args[0]),srate,bufferSize,bufferSizeJavaSound);
        } catch (java.io.FileNotFoundException ee) {
            System.out.println("Modes file not found\n");
        }
        AudioForce af = new MikeAudioForce(srate,bufferSizeJavaSound);
        sob.setAudioForce(af);
        sob.setAGC(true);
        sob.start();
    }
}
