/**
    White noise force.
    Copyright The University of British Columbia, Canada
    @author Kees van den Doel (kvdoel@cs.ubc.ca)
*/
public class WhiteNoiseForce implements AudioForce {

    /** Create force.
        @param output user provided buffer for force returned.
        @param nsamples number of samples written to output buffer.
    */
    public void getForce(float [] output, int nsamples) {
        for(int i=0;i<nsamples;i++) {
            output[i] = (float)(2*Math.random() - 1.);
        }
    }    
}



